## immer 0.1-1

=== DESCRIPTION ===
Package: immer
Type: Package
Title: Item Response Models for Multiple Ratings
Version: 0.1-1
Date: 2015-09-13
Author: Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
Maintainer: Alexander Robitzsch <a.robitzsch@bifie.at>
Description: 
 Implements some item response models for multiple
 ratings, including the hierarchical rater model, 
 conditional maximum likelihood estimation of linear 
 logistic partial credit model and a wrapper function
 to the commercial FACETS program.
Depends: R (>= 3.0-0)
Imports: methods, stats, graphics, Rcpp, coda, CDM, sirt, psychotools
Suggests: irr, TAM, eRm
LinkingTo: Rcpp, RcppArmadillo
License: GPL (>= 2)
Packaged: 2015-09-13 17:52:32 UTC; robitzsch
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2015-09-14 09:12:50
