## immer 0.4-0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 0.3-0
-Date: 2016-01-22
+Version: 0.4-0
+Date: 2016-03-07
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: 
@@ -19,6 +19,6 @@
 LinkingTo: Rcpp, RcppArmadillo
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2016-01-22 17:18:05 UTC; sunpn563
+Packaged: 2016-03-07 15:42:44 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2016-01-23 00:37:25
+Date/Publication: 2016-03-07 22:38:50
