## immer 0.5-0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 0.4-0
-Date: 2016-03-07
+Version: 0.5-0
+Date: 2016-05-31
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: 
@@ -19,6 +19,6 @@
 LinkingTo: Rcpp, RcppArmadillo
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2016-03-07 15:42:44 UTC; sunpn563
+Packaged: 2016-05-31 12:34:57 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2016-03-07 22:38:50
+Date/Publication: 2016-05-31 14:46:59
