## immer 0.6-0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 0.5-0
-Date: 2016-05-31
+Version: 0.6-0
+Date: 2016-10-28
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
-Maintainer: 
- Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
+Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
 Description: 
     Implements some item response models for multiple
     ratings, including the hierarchical rater model, 
@@ -19,6 +18,6 @@
 LinkingTo: Rcpp, RcppArmadillo
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2016-05-31 12:34:57 UTC; sunpn563
+Packaged: 2016-10-28 15:41:52 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2016-05-31 14:46:59
+Date/Publication: 2016-10-29 00:11:53
