## immer 0.7-0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: immer
 Type: Package
 Title: Item Response Models for Multiple Ratings
-Version: 0.6-0
-Date: 2016-10-28
+Version: 0.7-0
+Date: 2017-01-18
 Author: 
     Alexander Robitzsch [aut, cre], Jan Steinfeld [aut]
 Maintainer: Alexander Robitzsch <robitzsch@ipn.uni-kiel.de>
@@ -18,6 +18,6 @@
 LinkingTo: Rcpp, RcppArmadillo
 License: GPL (>= 2)
 NeedsCompilation: yes
-Packaged: 2016-10-28 15:41:52 UTC; sunpn563
+Packaged: 2017-01-18 18:37:23 UTC; sunpn563
 Repository: CRAN
-Date/Publication: 2016-10-29 00:11:53
+Date/Publication: 2017-01-18 23:57:09
