## immer 0.8.0+dfsg

=== debian/changelog ===
immer (0.8.0+dfsg-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 05 Oct 2023 11:57:58 -0700

immer (0.8.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.
  * doctest-SIGSTKSZ.diff: mention https://github.com/arximboldi/immer/pull/266
    that fixes the problem in future versions.
  * Fix a typo in copyright.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Aug 2023 05:00:58 +0200

immer (0.8.0+dfsg-1) experimental; urgency=medium

  * Initial packaging.

 -- Pino Toscano <pino@debian.org>  Fri, 28 Jul 2023 12:11:36 +0200
