=== debian/rules ===
#!/usr/bin/make -f

# https://github.com/arximboldi/immer/issues/223
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-array-bounds

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	  -DDISABLE_WERROR=ON \
	  -Dimmer_BUILD_EXAMPLES=OFF \
	  -Dimmer_BUILD_DOCS=OFF \
	  -Dimmer_BUILD_EXTRAS=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- tests
endif

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym
