=== debian/changelog ===
immer (0.8.1+dfsg-2) unstable; urgency=medium

  * Disable the tests for now: they assume Catch2 v2.x, and v3 requires changes.
    (Closes: #1054710)

 -- Pino Toscano <pino@debian.org>  Sat, 28 Oct 2023 05:17:59 +0200

immer (0.8.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Change the 'build-examples' autopkgtest to use the upstream CMakeLists.txt
    of the examples.
  * Update the patches:
    - upstream_Fix-includes.patch: drop, backported from upstream
    - doctest-SIGSTKSZ.diff: drop, the embedded copy of doctest was dropped
  * Update the build dependencies according to the upstream build system:
    - add catch2
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Wed, 04 Oct 2023 06:36:24 +0200
