=== debian/control ===
Source: immer
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: catch2,
               cmake (>= 3.5.1~),
               debhelper-compat (= 13),
               libboost-dev (>= 1.56~),
               libfmt-dev <!nocheck>,
               libgc-dev,
               pkg-config,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/arximboldi/immer
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/immer
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/immer.git

Package: libimmer-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libgc-dev,
Description: persistent and immutable data structures -- development files
 immer is a library of persistent and immutable data structures written in C++.
 These enable whole new kinds of architectures for interactive and concurrent
 programs of striking simplicity, correctness, and performance.
 .
 This package contains the development files.
