=== debian/tests/control ===
Tests: build-examples
Depends: build-essential, cmake, libimmer-dev
Restrictions: allow-stderr
