=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%, repacksuffix=+dfsg, dversionmangle=auto" \
https://github.com/arximboldi/immer/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
