=== extra/fuzzer/persist/CMakeLists.txt ===
find_package(fmt REQUIRED)

file(GLOB_RECURSE immer_fuzzers "*.cpp")
foreach(_file IN LISTS immer_fuzzers)
  immer_target_name_for(_target _output "${_file}")
  add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
  set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
  target_compile_options(${_target} PUBLIC ${immer_fuzzing_engine})
  target_compile_options(${_target} PRIVATE ${immer_fuzzing_engine}
                                            -Wno-c++20-designator)
  target_include_directories(${_target} PRIVATE ../..)
  target_link_libraries(${_target} PUBLIC ${immer_fuzzing_engine} immer-dev)
  add_dependencies(fuzzers ${_target})
  if(CHECK_FUZZERS)
    add_test("fuzzer/${_output}" ${_output} -max_total_time=1)
  endif()
  if(immer_INSTALL_FUZZERS)
    install(TARGETS ${_target} DESTINATION bin)
  endif()
endforeach()
