=== debian/changelog ===
immer (0.9.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.14
  * Switch the transitional pkg-config build dependency to pkgconf.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.

 -- Pino Toscano <pino@debian.org>  Sun, 14 Dec 2025 20:49:29 +0100
