=== debian/control ===
--- 
+++ 
@@ -4,14 +4,13 @@
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: catch2,
-               cmake (>= 3.5.1~),
+               cmake (>= 3.14~),
                debhelper-compat (= 13),
                libboost-dev (>= 1.56~),
                libfmt-dev <!nocheck>,
                libgc-dev,
-               pkg-config,
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+               pkgconf,
+Standards-Version: 4.7.2
 Homepage: https://github.com/arximboldi/immer
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/immer
 Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/immer.git
